/*
 *
 *  Created on: 12.11.2011
 *      Author: klausj
 */

#ifndef JNM_AUDIOSINK_H_
#define JNM_AUDIOSINK_H_
#include <jni.h>
#include <glib-object.h>
//#include "jnm_decodingplayer.h"

#include <gst/gst.h>
#include <gst/audio/gstaudiosink.h>
#ifdef __cplusplus
extern "C" {
#endif
JNIEXPORT jobject JNICALL Java_de_klausj_video_impl_gstreamer_AudioSink_init(JNIEnv *,jobject);
JNIEXPORT void JNICALL Java_de_klausj_video_impl_gstreamer_AudioSink_configure(JNIEnv *, jobject,jobject,jobject,jboolean);
JNIEXPORT void JNICALL Java_de_klausj_video_impl_gstreamer_AudioSink_gMainLoopRun(JNIEnv *, jobject,jobject);
JNIEXPORT void JNICALL Java_de_klausj_video_impl_gstreamer_AudioSink_open(JNIEnv *, jobject,jobject,jstring);
JNIEXPORT void JNICALL Java_de_klausj_video_impl_gstreamer_AudioSink_start(JNIEnv *, jobject,jobject);
JNIEXPORT void JNICALL Java_de_klausj_video_impl_gstreamer_AudioSink_stop(JNIEnv *, jobject,jobject);
JNIEXPORT void JNICALL Java_de_klausj_video_impl_gstreamer_AudioSink_rewind(JNIEnv *, jobject,jobject);
JNIEXPORT jlong JNICALL Java_de_klausj_video_impl_gstreamer_AudioSink_getDuration(JNIEnv *, jobject,jobject);
JNIEXPORT jlong JNICALL Java_de_klausj_video_impl_gstreamer_AudioSink_getPosition(JNIEnv *, jobject,jobject);
#ifdef __cplusplus
}
#endif
#define JNM_TYPE_AUDIOSINK         (jnm_audiosink_get_type ())

struct _JnmAudioSinkPrivate
{
  //int hsize;
  gchar *msg;
};

typedef struct _JnmAudioSinkPrivate JnmAudioSinkPrivate;

/* object */
struct _JnmAudioSink
{
   // GObject parent_instance;
    GstAudioSink parent_instance;
    /* public */
    //int public_int;
    JavaVM *javaVM;
    jobject jClassRef;
    jobject javaObjRef;
    GstPadTemplate *gstSinkPadTemplate;
    void *mediaDecodingPlayer;
    jmethodID jaudioWriteMethodId;
    jmethodID jaudioDelayMethodId;
    volatile pthread_t audioNativeThreadID;
     JNIEnv *audioJEnv;
     volatile    pthread_t audioDelayNativeThreadID;
     JNIEnv *audioDelayEnv;
    guint delay;
    /*< private >*/
    JnmAudioSinkPrivate *priv;
};

/* class */
struct _JnmAudioSinkClass
{
    //GObjectClass parent_class;

    /* class members */

    /* Virtual public method */
    //void (*do_action_virt) (JnmAudioSink *self, gchar *msg);
    GstAudioSinkClass parent_class;
    //GstFlowReturn  (*show_frame) (GstAudioSink *audio_sink, GstBuffer *buf);
};



typedef struct _JnmAudioSink        JnmAudioSink;
typedef struct _JnmAudioSinkClass   JnmAudioSinkClass;


gboolean      jnm_audiosink_set_caps (GstBaseSink *, GstCaps *);
//GstFlowReturn  jnm_audiosink_show_frame(GstAudioSink *audio_sink, GstBuffer *buf);
gboolean jnm_audiosink_open(GstAudioSink *sink);
 /* prepare resources and state to operate with the given specs */
 gboolean jnm_audiosink_prepare(GstAudioSink *sink, GstAudioRingBufferSpec *spec);
 /* undo anything that was done in prepare() */
 gboolean jnm_audiosink_unprepare(GstAudioSink *sink);
 /* close the device */
 gboolean jnm_audiosink_close(GstAudioSink *sink);
 /* write samples to the device */
 /* FIXME 0.11: change return value to gint, as most implementation use that
  * already anyway */
 gint   jnm_audiosink_write(GstAudioSink *sink, gpointer data, guint length);
 /* get number of samples queued in the device */
 guint   jnm_audiosink_delay(GstAudioSink *sink);
 /* reset the audio device, unblock from a write */
 void    jnm_audiosink_reset(GstAudioSink *sink);
// void jnm_audiosink_release(JnmAudioSink *as);
GType jnm_audiosink_get_type ();

#endif
